//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  Orange
#property indicator_color4  Orange
#property indicator_color5  DarkGray
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_level1  0

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame = PERIOD_CURRENT;
extern int    Length          = 25;
extern ENUM_APPLIED_PRICE Price = PRICE_CLOSE;
extern double Lambda          = 5;
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsOnSlope   = true;
extern bool   alertsOnZeroCross = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = true;
extern bool   alertsNotify    = true;
extern bool   Interpolate     = true;

//
//
//
//
//

double mom[];
double rema[];
double huu[];
double hud[];
double hdd[];
double hdu[];
double slope[];
double cross[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
      SetIndexBuffer(0,huu); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,hud); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,hdd); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,hdu); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,mom);
      SetIndexBuffer(5,rema);
      SetIndexBuffer(6,slope);
      SetIndexBuffer(7,cross);
         indicatorFileName   = WindowExpertName();
         returnBars          = TimeFrame==-99;
         TimeFrame           = MathMax(TimeFrame,_Period);
         IndicatorShortName(timeFrameToString(TimeFrame)+" Regularized momentum ("+Length+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { huu[0] = limit+1; return(0); }
         if (TimeFrame!=Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for(i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);
                  mom[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Length,Price,Lambda,alertsOn,alertsOnCurrent,alertsOnSlope,alertsOnZeroCross,alertsMessage,alertsSound,alertsEmail,alertsNotify,4,y);
                  slope[i] = slope[i+1];
                  huu[i]   = EMPTY_VALUE;
                  hud[i]   = EMPTY_VALUE;
                  hdd[i]   = EMPTY_VALUE;
                  hdu[i]   = EMPTY_VALUE;
                     if (mom[i] > mom[i+1]) slope[i] =  1;
                     if (mom[i] < mom[i+1]) slope[i] = -1;
                     if (slope[i]== 1 && mom[i]>0) huu[i] = mom[i];
                     if (slope[i]==-1 && mom[i]>0) hud[i] = mom[i];
                     if (slope[i]==-1 && mom[i]<0) hdd[i] = mom[i];
                     if (slope[i]== 1 && mom[i]<0) hdu[i] = mom[i];
                     
                     //
                     //
                     //
                     //
                     //
                     
                      if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

                     //
                     //
                     //
                     //
                     //

                     datetime time = iTime(NULL,TimeFrame,y);
                        for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
                        for(int s = 1; s < n; s++) 
                        {
  	                        mom[i+s] = mom[i] + (mom[i+n] - mom[i])* s/n;
                              if (huu[i]!=EMPTY_VALUE) huu[i+s] = mom[i+s];
                              if (hud[i]!=EMPTY_VALUE) hud[i+s] = mom[i+s];
                              if (hdu[i]!=EMPTY_VALUE) hdu[i+s] = mom[i+s];
                              if (hdd[i]!=EMPTY_VALUE) hdd[i+s] = mom[i+s];
                        }
            }       
            return(0);
         }

   //
   //
   //
   //
   //

   double alpha = 2.0 / (1.0*Length);      
   double regf1 = (1.0+Lambda*2.0);
   double regf2 = (1.0+Lambda);
   for(i=limit; i>=0; i--) 
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      if (Bars-i>1)
            rema[i] = (regf1*rema[i+1]+alpha*(price-rema[i+1])-Lambda*rema[i+2])/regf2;
      else  rema[i] = price;
      mom[i] = (rema[i]-rema[i+1])/rema[i];
         slope[i] = slope[i+1];
         huu[i]   = EMPTY_VALUE;
         hud[i]   = EMPTY_VALUE;
         hdd[i]   = EMPTY_VALUE;
         hdu[i]   = EMPTY_VALUE;
            if (mom[i] > mom[i+1]) slope[i] =  1;
            if (mom[i] < mom[i+1]) slope[i] = -1;
            if (slope[i]== 1 && mom[i]>0) huu[i] = mom[i];
            if (slope[i]==-1 && mom[i]>0) hud[i] = mom[i];
            if (slope[i]==-1 && mom[i]<0) hdd[i] = mom[i];
            if (slope[i]== 1 && mom[i]<0) hdu[i] = mom[i];
            cross[i] = cross[i+1];
               if (mom[i]>0) cross[i] =  1;
               if (mom[i]<0) cross[i] = -1;
   }   
   
   //
   //
   //
   //
   //
    
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1; 
      
     //
     //
     //
     //
     //
      
      if (alertsOnSlope)
      {
         static string   mess1 = "";
         static datetime time1 = 0;      
            if (huu[whichBar+1] == EMPTY_VALUE && huu[whichBar] != EMPTY_VALUE) doAlert(mess1,time1,whichBar,"sloping up and greater than zero");
            if (hud[whichBar+1] == EMPTY_VALUE && hud[whichBar] != EMPTY_VALUE) doAlert(mess1,time1,whichBar,"sloping down and less than zero");
            if (hdd[whichBar+1] == EMPTY_VALUE && hdd[whichBar] != EMPTY_VALUE) doAlert(mess1,time1,whichBar,"sloping down and less than zero");
            if (hdu[whichBar+1] == EMPTY_VALUE && hdu[whichBar] != EMPTY_VALUE) doAlert(mess1,time1,whichBar,"sloping up and less than zero");
      }
      if (alertsOnZeroCross)
      {
         static string   mess2 = "";
         static datetime time2 = 0;      
         if (cross[whichBar]!=cross[whichBar+1])
         {            
            if (cross[whichBar] ==  1) doAlert(mess2,time2,whichBar,"zero line crossed up");
            if (cross[whichBar] == -1) doAlert(mess2,time2,whichBar,"zero line crossed down");
         }            
      }         
    }            
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Regularized momentum ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " Regularized momentum "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}